import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import freemarker.template.*;

public class HelloServlet extends HttpServlet {

        TemplateCache templateCache = new FileTemplateCache(HelloServlet.class);

	public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {

		res.setContentType("text/html");
		PrintWriter out = res.getWriter();

		// Make a template data model.
		SimpleHash modelRoot = new SimpleHash();
		modelRoot.put("message", new SimpleScalar("Hello, world!"));
                Template template = templateCache.getTemplate("hello-world.html");
		// Process the template.
		try {
			template.process(modelRoot, out);
		} catch( TemplateException e ) {
			// Failure case
		}
		
		out.close();
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {
		doGet(req, res);
	}
}
