/*
 * FreeMarker: a tool that allows Java programs to use templates
 * to generate HTML or other text output that contains dynamic content.
 * Copyright (C) 1998,2002 Benjamin Geer
 * Email: beroul@users.sourceforge.net
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * Neither the name "Freemarker" nor any of the names of the project 
 * contributors may be used to endorse or promote products 
 * derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

package freemarker.testcase;

import java.io.IOException;
import junit.framework.*;

/**
 * Dummy test case. This tests the AbstractTestCase class, by generating
 * a test that is identical to the reference text. The input file is identical
 * to the template file, and no transformation is performed.
 *
 * @version $Id: DummyTestCase.java,v 1.7 2002/03/09 20:57:05 revusky Exp $
 */
public class DummyTestCase extends AbstractTestCase {

    /** Creates new DummyTestCase, with a filename for the reference and
     * template files.
     */
    public DummyTestCase( String aTestname ) {
        super( aTestname );
    }

    public void setUp() {
        setUpFiles( "test-dummy.html" );
    }

    /**
     * Performs the test.
     */
    public void runTest() {
        String aOutput;

        aOutput =  m_aTemplateText;
        showTestResults( m_aReferenceText, aOutput );
    }

    /**
     * Main method for caaling the test in standalone mode.
     */
    public static void main(String args[]) {
        AbstractTestCase cTester = new DummyTestCase( "test-dummy.html" );
        TestResult cResults = new TestResult();

        cTester.run( cResults );
    }
}
